﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SuperWebSocket;

namespace WebSocketBasicDemo.Server
{
    class Program
    {
        private const string wsIP = "127.0.0.1";
        private const int wsPort = 2012;

        static void Main(string[] args)
        {
            var ws = new WebSocketServer();
            if (!ws.Setup(wsIP, wsPort))
            {
                Console.WriteLine("设置WebSocket服务端IP Port失败");
                return;
            }

            ws.NewSessionConnected += ws_NewSessionConnected;
            ws.SessionClosed += ws_SessionClosed;
            ws.NewMessageReceived += ws_NewMessageReceived;


            if (!ws.Start())
            {
                Console.WriteLine("开启WebSocket服务侦听失败");
                return;
            }

            Console.WriteLine("侦听服务以启动 按'q'键关闭服务");


            while ('q' == Console.ReadKey().KeyChar) ;
            {
                Console.WriteLine("关闭服务侦听");
                ws.Stop();
            }


        }

        static void ws_NewSessionConnected(WebSocketSession session)
        {
            Console.WriteLine("{0:HH:MM:ss} 客户端:{1} 连接服务器 ", DateTime.Now, session.RemoteEndPoint);
        }

        static void ws_SessionClosed(WebSocketSession session, SuperSocket.SocketBase.CloseReason value)
        {
            Console.WriteLine("{0:HH:MM:ss} 客户端:{1} 与服务器断开连接  原因:{2} ", DateTime.Now, session.RemoteEndPoint, value);
        }


        static void ws_NewMessageReceived(WebSocketSession session, string value)
        {
            Console.WriteLine(string.Format("{0:HH:MM:ss} 接收到来自客户端{1}的消息:{2}", DateTime.Now, session.RemoteEndPoint, value));

            session.Send(string.Format("服务端已经收到消息:{0}", value));
        }
    }
}
